unit UMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, FileCtrl, StdCtrls, ComCtrls,
  CheckLst, Buttons,db,Dbtables, Menus, UAspFileDataSet;

type
  TfMain = class(TForm)
    Panel1: TPanel;
    Splitter1: TSplitter;
    Panel2: TPanel;
    ExpDS: TAspFileDataSource;
    AspFileDBNavigator1: TAspFileDBNavigator;
    Panel3: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    lbRecCount: TLabel;
    LbDBFileName: TLabel;
    Button1: TButton;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    Label6: TLabel;
    lbFdCount: TLabel;
    ExpMain: TAspFileDataSet;
    Panel4: TPanel;
    GroupBox2: TGroupBox;
    FilterCmd: TMemo;
    Panel6: TPanel;
    Button3: TButton;
    Button4: TButton;
    Panel5: TPanel;
    Label5: TLabel;
    DriveComboBox2: TDriveComboBox;
    DirectoryListBox2: TDirectoryListBox;
    Button2: TButton;
    FileListBox2: TFileListBox;
    Splitter2: TSplitter;
    Panel7: TPanel;
    Label1: TLabel;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    Panel8: TPanel;
    Label2: TLabel;
    TableList: TListBox;
    Button6: TButton;
    Button5: TButton;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    BitBtn1: TBitBtn;
    Button8: TButton;
    GridPanel: TScrollBox;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    procedure AspFileDBNavigator1AfterNavBtnClick(Sender: TComponent;
      BtnName: String);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure TableListClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure N8Click(Sender: TObject);
    procedure N10Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    DataGrid:TAspFileDBGrid;
    CurrentFileName:string;
  end;

var
  fMain: TfMain;

implementation

uses UfTableAdd;

{$R *.dfm}

procedure TfMain.AspFileDBNavigator1AfterNavBtnClick(Sender: TComponent;
                                                     BtnName: String);
begin
  if(BtnName = 'Post')or(BtnName = 'Delete')then
    lbRecCount.Caption := IntToStr(ExpMain.RecDataSet.RecordCount);
end;

procedure TfMain.Button1Click(Sender: TObject);
begin
  if(ExpMain.Active = FALSE)then Exit;
  ExpMain.RecDataSet.UnLockCurrentRecord;
end;

procedure TfMain.Button2Click(Sender: TObject);
var lt:TStrings;
    i:integer;
begin
  try
   lt := TStringList.Create;
   if(trim(FileListBox2.FileName) <> '')then
     begin
       lt.LoadFromFile(FileListBox2.FileName);
       for i := 0 to lt.Count-1 do
         begin
           FilterCmd.Lines.Add(lt[i]);
         end;//for...i...end!!
     end;//if...end!!
  finally
   lt.Clear;
   lt.Free;
  end;//try...end!!
end;

procedure TfMain.Button3Click(Sender: TObject);
var i:integer;
begin
  Button3.Cursor := crHourGlass;
  self.ExpMain.RecDataSet.DeleteAllDataFilters;
  for i := 0 to self.FilterCmd.Lines.Count-1 do
    if(trim(self.FilterCmd.Lines[i]) <> '')then
      self.ExpMain.RecDataSet.AddDataFilterWithCommandStr(self.FilterCmd.Lines[i]);
  if(self.ExpMain.RecDataSet.DataFilterCount > 0)then
    self.ExpMain.RecDataSet.UseFilter := TRUE;
  lbRecCount.Caption := IntToStr(ExpMain.RecDataSet.RecordCount);
  Button3.Cursor := crDefault;
end;

procedure TfMain.Button4Click(Sender: TObject);
begin
  self.ExpMain.RecDataSet.UseFilter := FALSE;
  lbRecCount.Caption := IntToStr(ExpMain.RecDataSet.RecordCount);
end;

procedure TfMain.Button5Click(Sender: TObject);
begin
  self.ExpMain.RecDataSet.UseFilter := FALSE;
  self.ExpMain.RecDataSet.DeleteAllDataFilters;
  self.FilterCmd.Lines.Clear;
  lbRecCount.Caption := IntToStr(ExpMain.RecDataSet.RecordCount);
end;

procedure TfMain.Button6Click(Sender: TObject);
var dlg:TSaveDialog;
begin
  if(self.FilterCmd.Lines.Count = 0)then Exit;
  try
    dlg := TSaveDialog.Create(nil);
    dlg.Filter     := '*.FDC';
    dlg.DefaultExt := 'FDC';
    if(dlg.Execute = TRUE)then self.FilterCmd.Lines.SaveToFile(dlg.FileName);
  finally
    dlg.Free;
  end;//try...end!!
end;

procedure TfMain.DirectoryListBox1Change(Sender: TObject);
var i,strID:integer;
    tbstr:string;
  function GetTableName(inFileStr:string):string;
  var i:integer;
      rstr:string;
  begin
    result := '';  rstr := '';
    for i := 1 to Length(inFileStr) do
      if(inFileStr[i] = '.')then Break
      else rstr := rstr+inFileStr[i];
    result := rstr;
  end;//func...end!!
begin
  tbstr := '';
  TableList.Items.Clear;
  DirectoryListBox1.FileList := nil;
  self.FileListBox1.Mask := '*.XDB';
  DirectoryListBox1.FileList := self.FileListBox1;
  for i := 0 to self.FileListBox1.Items.Count-1 do
    begin
      tbstr := GetTableName(self.FileListBox1.Items[i]);
      strID := TableList.Items.IndexOf(tbstr);
      if(strID = -1)then TableList.Items.Add(tbStr);
    end;//for...i...end!!
  //====================================================
  self.FileListBox1.Mask := '*.SFD';
  for i := 0 to self.FileListBox1.Items.Count-1 do
    begin
      tbstr := GetTableName(self.FileListBox1.Items[i]);
      strID := TableList.Items.IndexOf(tbstr);
      if(strID = -1)then TableList.Items.Add(tbStr);
    end;//for...i...end!!
  //====================================================
end;

procedure TfMain.TableListClick(Sender: TObject);
var i:integer;
    PathStr,fstr:string;
    tmpGrid:TAspFileDBGrid;
    Label NextStep;
begin
  if(TableList.ItemIndex >= 0)then
    begin
      tmpGrid := nil;
      if(self.DataGrid <> nil)then
       begin
         tmpGrid := self.DataGrid;
         tmpGrid.Visible := FALSE;
         tmpGrid.DisableRefreshData;
       end;//if...end!!
      TableList.Cursor := crHourGlass;
      self.DataGrid.Free;
      self.DataGrid := nil;
      self.DataGrid := TAspFileDBGrid.Create(nil);
      self.DataGrid.AutoSize := TRUE;
      self.DataGrid.Parent   := GridPanel;
      self.DataGrid.Color    := GridPanel.Color;
      if(ExpMain.Active = TRUE)then
        begin
          ExpMain.RecDataSet.UseFilter := FALSE;
          ExpMain.Active      := FALSE;
          ExpMain.AccessFile  := '';
        end;//if...end!!
      //------------------------------------------------------------------
      PathStr := self.DirectoryListBox1.Directory;
      fstr    := TableList.Items[TableList.ItemIndex]+'.XDB';
      if(FileExists(PathStr+'\'+fstr) = TRUE)then
        begin
          ExpMain.AccessFile   := PathStr+'\'+fstr;
          ExpMain.AccessUser   := 'Explorer';
          LbDBFileName.Caption := TableList.Items[TableList.ItemIndex];
          if(ExpMain.RecDataSet.DataFileSize = 0)then Goto NextStep
          else
            begin
              ExpMain.Active      := TRUE;
              lbRecCount.Caption  := IntToStr(ExpMain.RecDataSet.RecordCount);
              lbFdCount .Caption  := IntToStr(ExpMain.RecDataSet.FieldCount);
              DataGrid.DataSource := self.ExpDS;
              ExpMain.RecDataSet.RecFirst;
            end;//else...end!!
        end //if...end!!
      else
        begin
          NextStep:
          DataGrid.DataSource := nil;
          ExpMain.Active      := FALSE;
          fstr := '';
          fstr := TableList.Items[TableList.ItemIndex];
          if(FileExists(PathStr+'\'+fstr+'.SFD') = TRUE)then
            begin
              ExpMain.AccessFile   := PathStr+'\'+fstr+'.XDB';
              ExpMain.AccessUser   := 'admin';
              LbDBFileName.Caption := fstr;
              ExpMain.RecDataSet.LoadSchema(PathStr+'\'+fstr+'.SFD');
              ExpMain.Active       := TRUE;
              lbRecCount.Caption   := IntToStr(ExpMain.RecDataSet.RecordCount);
              lbFdCount .Caption   := IntToStr(ExpMain.RecDataSet.FieldCount);
              DataGrid.DataSource  := self.ExpDS;
              ExpMain.RecDataSet.RecFirst;
            end;//if...end;
        end;//else...end!!

      if(GridPanel.Width <> self.DataGrid.Width)then
        self.DataGrid.Width := GridPanel.Width+10;
      //========================================================================
      tmpGrid := nil;
    end;//if...end!!
   TableList.Cursor := crDefault;
end;

procedure TfMain.FormCreate(Sender: TObject);
var str,driveStr,FolderStr,FileStr:string;
    idx,i:integer;
begin
  self.DataGrid := nil;
  DirectoryListBox1Change(nil);
  self.ExpMain.RecDataSet.CompressData := TRUE;
  self.ExpMain.RecDataSet.EncryptData  := TRUE;
  if(ParamCount > 0)then
    begin
      str := ParamStr(1);
      if(Uppercase(str) = 'EXIT')then Application.Terminate
      else
        if(FileExists(str) = TRUE)then
          begin
            driveStr  := ExtractFileDrive(str);
            DriveComboBox1.Drive := driveStr[1];
            //-----------------------------------
            FolderStr := ExtractFileDir(str);
            DirectoryListBox1.Directory := FolderStr;
            //---------------------------------------
            FileStr   := ExtractFileName(str);
            str := '';
            for i := 1 to Length(FileStr) do
              if(FileStr[i] = '.')then Break
              else str := str+FileStr[i];
            //----------------------------------
            idx := TableList.Items.IndexOf(str);
            TableList.ItemIndex := idx;
            TableList.OnClick(nil);
          end;//else...if...end!!
    end;//if...end!!
end;

procedure TfMain.N1Click(Sender: TObject);
var Pathstr:string;
    tbStr,NewtbStr:string;
begin
  //󴫦W
  if(TableList.ItemIndex >= 0)then
    begin
      self.ExpMain.Active := FALSE;
      NewtbStr := '';
      Pathstr  := self.DirectoryListBox1.Directory;
      tbStr    := TableList.Items[TableList.ItemIndex];
      NewtbStr := InputBox('קƪW'
                           ,'JsƪW'
                           ,tbStr);
      if(NewtbStr = tbStr)then Exit;
      if(FileExists(Pathstr+'\'+tbStr+'.SFD') = TRUE)then
        begin
          RenameFile( Pathstr+'\'+tbStr+'.SFD'
                     ,Pathstr+'\'+NewtbStr+'.SFD');
        end;//if...end!!  

      if(FileExists(Pathstr+'\'+tbStr+'.XDB') = TRUE)then
        begin
          RenameFile( Pathstr+'\'+tbStr+'.XDB'
                     ,Pathstr+'\'+NewtbStr+'.XDB');
        end;//if...end!!
      DirectoryListBox1Change(nil);
    end;//if...end!!
end;

procedure TfMain.N3Click(Sender: TObject);
begin
  //MҦ
  if(TableList.ItemIndex >= 0)then
    begin
      if(self.ExpMain.Active = TRUE)then
      while(self.ExpMain.RecDataSet.RecordCount > 0)do
        begin
          Application.ProcessMessages;
          self.ExpMain.RecDataSet.UnLockCurrentRecord;
          self.ExpMain.RecDataSet.RecDelete;
          lbRecCount.Caption  := IntToStr(ExpMain.RecDataSet.RecordCount);
        end;//while...end!!
    end;//if...end!!
end;

procedure TfMain.N4Click(Sender: TObject);
var Pathstr:string;
    tbStr:string;
begin
  //Rƪ
  if(TableList.ItemIndex >= 0)then
    begin
      LbDBFileName.Caption     := '';
      self.DataGrid.DisableRefreshData;
      self.DataGrid.Visible    := FALSE;
      self.ExpMain.Active      := FALSE;
      self.ExpMain.AccessFile  := '';
      Pathstr  := self.DirectoryListBox1.Directory;
      tbStr    := TableList.Items[TableList.ItemIndex];
      if(FileExists(Pathstr+'\'+tbStr+'.SFD') = TRUE)then
        DeleteFile(Pathstr+'\'+tbStr+'.SFD');
      if(FileExists(Pathstr+'\'+tbStr+'.XDB') = TRUE)then
        DeleteFile( Pathstr+'\'+tbStr+'.XDB');
      TableList.ItemIndex := -1;
      lbRecCount.Caption  := '0';
      lbFdCount .Caption  := '0';
      self.DataGrid.DataSource := nil;
      self.DataGrid.Free;
      self.DataGrid := nil;
      DirectoryListBox1Change(nil);
    end;//if...end!!  
end;

procedure TfMain.FormDestroy(Sender: TObject);
begin
  if(self.DataGrid <> nil)then
    begin
      self.DataGrid.Visible := FALSE;
      DataGrid.DataSource   := nil;
      self.DataGrid.Free;
      self.DataGrid := nil;
    end;//if...end!!
end;

procedure DataSchemaToFile(inDataSet:TAspFileDataSet;SchemaFileName: string);
var i:integer;
    fstr,InternalSchema:string;
    strList:TStrings;
    function CreateSchema: string;
    var i:integer;
        rstr,FdName:string;
    begin
      result := ''; rstr := '';
      if(inDataSet.RecDataSet.FieldCount <= 0)then Exit;
      for i := 0 to (inDataSet.RecDataSet.FieldCount-1) do
        begin
          FdName := inDataSet.RecDataSet.FieldName[i];
          rstr := rstr+FdName;
          if(inDataSet.RecDataSet.GetAccessOBJ.FieldByName(FdName).CanNull = TRUE)then
            rstr := rstr+'.Y'
          else rstr := rstr+'.N';
          if(inDataSet.RecDataSet.GetAccessOBJ.FieldByName(FdName).IsKey = TRUE)then
            rstr := rstr+'.Y'
          else rstr := rstr + '.N';
          rstr := rstr+'.'+IntToStr(inDataSet.RecDataSet.FieldDataSize[FdName]);
          rstr := rstr+';';
        end;//for...i...end!!
      result := rstr;
    end;//Sub...Proc...end!!
begin
  fstr := '';
  if(inDataSet = nil)then Exit;
  if(trim(SchemaFileName) = '')then Exit;
  for i := 1 to Length(SchemaFileName) do
    if(SchemaFileName[i] <> '.')then
      fstr := fstr+SchemaFileName[i]
    else Break;
  if(trim(fstr) = '')then Exit;
  InternalSchema := CreateSchema;
  if(trim(InternalSchema) = '')then Exit;
  fstr := fstr+'.ESF';
  try
    strList := TStringList.Create;
    strList.Clear;
    strList.Add(InternalSchema);
    strList.SaveToFile(fstr);
  finally
    strList.Free;
  end;//try...end!!
end;

procedure TfMain.N6Click(Sender: TObject);
var InputString:string;
begin
  if(TableList.ItemIndex < 0)then Exit;
  InputString := InputBox( 'пJɮצW'
                          ,'XƪSchemar'
                          ,TableList.Items[TableList.ItemIndex]);
  DataSchemaToFile(self.ExpMain,InputString);
  ShowMessage('rxs!!');
end;

procedure TfMain.N7Click(Sender: TObject);
var i:integer;
    InputString:string;
begin
  for i := 0 to TableList.Items.Count-1 do
    begin
      TableList.ItemIndex := i;
      TableList.OnClick(nil);
      InputString := TableList.Items[TableList.ItemIndex];
      DataSchemaToFile(self.ExpMain,InputString);
    end;
end;

procedure TfMain.BitBtn1Click(Sender: TObject);
begin
  fTableAdd.EdTablePath.Text
    := self.DirectoryListBox1.Directory;
  fTableAdd.ShowModal;
  DirectoryListBox1Change(nil);
end;

procedure TfMain.Button8Click(Sender: TObject);
begin
  if(ExpMain.Active = FALSE)then Exit;
  ExpMain.RecDataSet.LockCurrentRecord('TEST');
end;

procedure TfMain.N8Click(Sender: TObject);
begin
  ExpMain.Active := FALSE;
  self.DataGrid.Free;
  self.DataGrid := nil;
end;

procedure TfMain.N10Click(Sender: TObject);
var OldFdNameStr,NewFdNameStr:string;
    IsChangeFdNameIsOk:OleVariant;
begin
  if(ExpMain.Active = FALSE)then Exit;
  ExpMain.First;
  OldFdNameStr := '';
  OldFdNameStr := InputBox('Input Old Field Name','Old Field Name : ','');
  if(trim(OldFdNameStr) <> '')and(ExpMain.IsThisFieldExists(OldFdNameStr) = TRUE)then
    begin
      NewFdNameStr := '';
      NewFdNameStr := InputBox('Input New Field Name','New Field Name : ','');
      if(trim(NewFdNameStr) <> '')then
        begin
          IsChangeFdNameIsOk := FALSE;
          ExpMain.RecDataSet.ChangeFieldName( OldFdNameStr
                                             ,NewFdNameStr
                                             ,IsChangeFdNameIsOk);
          if(IsChangeFdNameIsOk = TRUE)then
            begin
              ExpMain.Active := FALSE;
              self.DataGrid.Free;
              self.DataGrid  := nil;
              ExpMain.Active := TRUE;
              self.DataGrid  := TAspFileDBGrid.Create(nil);
              self.DataGrid.AutoSize   := TRUE;
              self.DataGrid.Parent     := GridPanel;
              self.DataGrid.DataSource := self.ExpDS;
            end;//if...end!!
        end;//if...end!!
    end;//if...end!!
end;

end.
